-- File: pushbtn.e
-- Description: Button library
-- Type: DOS32
-- Author: Hayden McKay
-- E-Mail: hmck1@dodo.com.au
-- Created: 29th/Nov/2003
-- Notes: -
--        * Please consult pushbtn.txt BEFORE any attempt to use this library.
--        * Details in the pushbtn.txt are as follows:
--               * Requirements
--               * Routines and syntax
--               * Setting up mouse checking loops
--               * Known issues
--               * Future developments
--               * Tips
--               * Advanced Programmers
--               * Licence
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
without warning
include mighty.e
include graphics.e
include putsxy.e
include image.e

integer error

global constant 
	      BR_SHAD = 1,
	      TR_SHAD = 2,
	      BL_SHAD = 3,
	      TL_SHAD = 4,
	      CNTR_SHAD = 5,
	      BR_SHAD_DBL = 6,
	      TR_SHAD_DBL = 7,
	      BL_SHAD_DBL = 8,
	      TL_SHAD_DBL = 9,
	      CNTR_SHAD_DBL = 10,
	      SP_BACK = 1,
	      ST_DOWN = 2,
	      LEFT = 1,
	      DOWN = 2
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--START BUTTON ROUTINES--
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
sequence button_status,button_number,button_rack
integer button_count,display_button,clear,link_status,link_reset,text_button
link_status = -1
button_number = {0}
button_count = 0
button_rack = {}
global procedure draw_button(integer color,integer shaddow,sequence top,sequence bottom,integer style,integer mode,sequence text,integer color_text,integer direction)
--Syntax check
if bottom[1] <= top[1] then
    text_color(4)
    bk_color(0)
    clear_screen()
    puts(1,"\nERROR....\n\n- Draw_button({top_X,top_Y},{bottom_X,bottom_Y})\n")
    puts(1,"- You specified sequences - top: ")
    print(1,top)
    puts(1,"\n                          - bottom: ")
    print(1,bottom)
    puts(1,"\n- 'Bottom X' must be greater than 'Top X'!")
    abort(1)
    elsif bottom[2] <= top[2] then
	text_color(4)
	bk_color(0)
	clear_screen()
	puts(1,"\nERROR....\n\n- Draw_button({top X, top Y},{bottom X,bottom Y})\n")
	puts(1,"- You specified sequences - top: ")
	print(1,top)
	puts(1,"\n                          - bottom: ")
	print(1,bottom)
	puts(1,"\n- 'Bottom Y' must be greater than 'Top Y'!")
	abort(1)
	elsif style > 10 then
	    text_color(4)
	    bk_color(0)
	    clear_screen()
	    puts(1,"\nERROR....\n\n- Draw_button(style)\n")
	    puts(1,"- You specified style ")
	    print(1,style)
	    puts(1,"\n- Style ")
	    print(1,style)
	    puts(1," is not a valid style!\n")
	    abort(1)
	    elsif mode > 2 then
		text_color(4)
		bk_color(0)
		clear_screen()
		puts(1,"\nERROR....\n\n- Draw_button(mode)\n")
		puts(1,"- You specified mode ")
		print(1,mode)
		puts(1,"\n- Mode ")
		print(1,mode)
		puts(1," is not a valid mode!\n")
		abort(1)
		elsif direction > 2 then
		    text_color(4)
		    bk_color(0)
		    clear_screen()
		    puts(1,"\nERROR...\n\n- Draw_button(direction)\n")
		    puts(1,"- You specified direction ")
		    print(1,direction)
		    puts(1,"\n- Direction ")
		    print(1,direction)
		    puts(1, " is not a valid direction!")
		    abort(1)
end if
--End syntax check
button_status = {}
button_number = button_number + 1
button_count = button_count + 1
button_status = {-1}
button_status = button_number & button_status
button_status = append(button_status,color & shaddow & top & bottom & style & mode)
button_status = append(button_status,text & color_text & direction)
button_rack = append(button_rack,button_status)
call_proc(display_button,{button_status})
end procedure
--------------------------------------------------------------------------------
procedure button_display(sequence button_status)
integer color,shaddow,style
sequence top,bottom
object mouse
color = button_status[3][1]
shaddow = button_status[3][2]
style = button_status[3][7]
top = button_status[3][3..4]
bottom = button_status[3][5..6]
if button_status[2] = -1 then
if style <= 10 then
    if style <= 3 then
	clear = get_pixel(top - 1)
	elsif style >= 6 and style <= 8 then
	    clear = get_pixel(top - 1)
	    elsif style = 4 or style = 9 then
		clear = get_pixel(bottom + 1)
    end if
    mouse_pointer(0)
    if style = 1 or style = 6 then
	polygon(clear,1,{top + 2,{bottom[1] + 2,top[2] + 2},bottom + 2,{top[1] + 2,bottom[2] + 2}})
	polygon(shaddow,1,{top + 4,{bottom[1] + 4,top[2] + 4},bottom + 4,{top[1] + 4,bottom[2] + 4}})
	elsif style = 2 or style = 7 then
	    polygon(clear,1,{{top[1] + 2,top[2] - 2},{bottom[1] + 2,top[2] - 2},{bottom[1] + 2,bottom[2] - 2},{top[1] + 2,bottom[2] - 2}})
	    polygon(shaddow,1,{{top[1] + 4,top[2] - 4},{bottom[1] + 4,top[2] - 4},{bottom[1] + 4,bottom[2] - 4},{top[1] + 4,bottom[2] - 4}})
	elsif style = 3 or style = 8 then
	    polygon(clear,1,{{top[1] - 2,top[2] + 2},{bottom[1] - 2,top[2] + 2},{bottom[1] - 2,bottom[2] + 2},{top[1] - 2,bottom[2] + 2}})                      
	    polygon(shaddow,1,{{top[1] - 4,top[2] + 4},{bottom[1] - 4,top[2] + 4},{bottom[1] - 4,bottom[2] + 4},{top[1] - 4,bottom[2] + 4}})
	elsif style = 4 or style = 9 then
	    polygon(clear,1,{top - 2,{bottom[1] - 2,top[2] - 2},bottom - 2,{top[1] - 2,bottom[2] - 2}})
	    polygon(shaddow,1,{top - 4,{bottom[1] - 4,top[2] - 4},bottom - 4,{top[1] - 4,bottom[2] - 4}})
	elsif style = 5 or style = 10 then
	    polygon(shaddow,1,{top - 3,{bottom[1] + 3,top[2] - 3},bottom + 3,{top[1] - 3,bottom[2] + 3}})
    end if
    polygon(color,1,{top,{bottom[1],top[2]},bottom,{top[1],bottom[2]}})
    call_proc(text_button,{button_status})
    draw_line(shaddow,{top,{bottom[1],top[2]},bottom,{top[1],bottom[2]},top})
    if style >= 6 then
	draw_line(shaddow,{top + 3,{bottom[1] - 3,top[2] + 3},bottom - 3,{top[1] + 3,bottom[2] - 3},top + 3})
    end if
end if
mouse_pointer(1)
end if
if button_status[2] = 1 then
if style <= 10 then
    mouse_pointer(0)
    polygon(clear,1,{top,{bottom[1],top[2]},bottom,{top[1],bottom[2]}})
    if style = 1 or style = 6 then
	polygon(color,1,{top + 2,{bottom[1] + 2,top[2] + 2},bottom + 2,{top[1] + 2,bottom[2] + 2}})
	draw_line(shaddow,{top + 2,{bottom[1] + 2,top[2] + 2},bottom + 2,{top[1] + 2,bottom[2] + 2},top + 2})
	if style = 6 then
	    draw_line(shaddow,{top + 5,{bottom[1] - 1,top[2] + 5},bottom - 1,{top[1] + 5,bottom[2] - 1},top + 5})
	end if
	elsif style = 2 or style = 7 then
	    polygon(color,1,{{top[1] + 2,top[2] - 2},{bottom[1] + 2,top[2] - 2},{bottom[1] + 2,bottom[2] - 2},{top[1] + 2,bottom[2] - 2}})
	    draw_line(shaddow,{{top[1] + 2,top[2] - 2},{bottom[1] + 2,top[2] - 2},{bottom[1] + 2,bottom[2] - 2},{top[1] + 2,bottom[2] - 2},{top[1] + 2,top[2] - 2}})
	    if style = 7 then
		draw_line(shaddow,{{top[1] + 5,top[2] + 1},{bottom[1] - 1,top[2] + 1},{bottom[1] - 1,bottom[2] - 5},{top[1] + 5,bottom[2] - 5},{top[1] + 5,top[2] + 1}})
	    end if
	elsif style = 3 or style = 8 then
	    polygon(color,1,{{top[1] - 2,top[2] + 2},{bottom[1] - 2,top[2] + 2},{bottom[1] - 2,bottom[2] + 2},{top[1] - 2,bottom[2] + 2}})
	    draw_line(shaddow,{{top[1] - 2,top[2] + 2},{bottom[1] -2,top[2] + 2},{bottom[1] - 2,bottom[2] + 2},{top[1] - 2,bottom[2] + 2},{top[1] - 2,top[2] + 2}})
	    if style = 8 then
		draw_line(shaddow,{{top[1] + 1,top[2] + 5},{bottom[1] - 5,top[2] + 5},{bottom[1] - 5,bottom[2] - 1},{top[1] + 1,bottom[2] - 1},{top[1] + 1,top[2] + 5}})
	    end if
	elsif style = 4 or style = 9 then
	    polygon(color,1,{top - 2,{bottom[1] - 2,top[2] - 2},bottom - 2,{top[1] - 2,bottom[2] - 2}})
	    draw_line(shaddow,{top - 2,{bottom[1] - 2,top[2] - 2},bottom - 2,{top[1] - 2,bottom[2] - 2},top - 2})
	    if style = 9 then
		draw_line(shaddow,{top + 1,{bottom[1] - 5,top[2] + 1},bottom - 5,{top[1] + 1,bottom[2] - 5},top + 1})
	    end if
	elsif style = 5 or style = 10 then
	    polygon(clear,1,{top - 3,{bottom[1] + 3,top[2] - 3},bottom + 3,{top[1] - 3,bottom[2] + 3}})                              
	    polygon(shaddow,1,{top,{bottom[1],top[2]},bottom,{top[1],bottom[2]}})
	    polygon(color,1,{top + 2,{bottom[1] - 2,top[2] + 2},bottom - 2,{top[1] + 2,bottom[2] - 2}})
	    if style = 10 then
		draw_line(shaddow,{top + 4,{bottom[1] - 4,top[2] + 4},bottom - 4,{top[1] + 4,bottom[2] - 4},top + 4})
	    end if
	end if
	call_proc(text_button,{button_status})
end if
mouse_pointer(1)
while 1 do
    mouse = get_mouse()
    if sequence(mouse) then
	if and_bits(mouse[1],LEFT_UP) then
	    exit
	end if
    end if
end while
end if
end procedure
display_button = routine_id("button_display")
--------------------------------------------------------------------------------
global function look_button(object mouse)
    integer clicked
    clicked = -1
    for i = 1 to button_count do
	if sequence(mouse) then
	   if and_bits(mouse[1],LEFT_DOWN) and mouse_inside(button_rack[i][3][3],button_rack[i][3][4],button_rack[i][3][5],button_rack[i][3][6]) then
	   clicked = i
	   end if
	end if
    end for
	if clicked > 0 then
	    if button_rack[clicked][3][8] = 1 then
	    button_rack[clicked][2] = 1
	    button_display(button_rack[clicked])
	    button_rack[clicked][2] = -1
	    button_display(button_rack[clicked])
	    if length(button_rack[clicked]) = 5 and button_rack[clicked][5][2] = 2 then
		call_proc(link_reset,{button_rack[clicked]})
		 elsif length(button_rack[clicked]) = 5 and button_rack[clicked][5][2] = 1 then
		    call_proc(link_reset,{button_rack[clicked]})
	    end if
	    elsif button_rack[clicked][3][8] = 2 then
		if button_rack[clicked][2] = -1 then
		    button_rack[clicked][2] = 1
		    button_display(button_rack[clicked])
		    if length(button_rack[clicked]) = 5 and button_rack[clicked][5][2] = 1 then
			call_proc(link_reset,{button_rack[clicked]})
		    end if
		    elsif button_rack[clicked][3][8] = 2 and length(button_rack[clicked]) = 4 then
--                      button_rack[clicked][2] = -1
--                      button_display(button_rack[clicked])
			clicked = -1
		end if
	    end if
	end if
    return clicked
end function 
--------------------------------------------------------------------------------
integer link_count
link_count = 0
global procedure link_button(sequence button_link,integer mode)
--Syntax check
    if length(button_link) > button_count then
	text_color(4)
	bk_color(0)
	clear_screen()
	puts(1,"\nERROR....\n\n- Link_button({sequence})\n- You specified ")
	print(1,length(button_link))
	puts(1," buttons to be linked!\n- There are only ")
	print(1,button_count)
	puts(1," buttons available.")
	abort(1)
    end if
    for i = 1 to length(button_link) by 1 do
	for j = 1 to button_count by 1 do
	    if equal(button_link[i],button_rack[j][1]) then
		error = j
		exit
	    end if
	end for
	if not equal(button_link[i],button_rack[error][1]) then
	    text_color(4)
	    bk_color(0)
	    clear_screen()
	    puts(1,"\nERROR....\n\n- Link_button({sequence})\n- You specified sequence ")
	    print(1,button_link)
	    puts(1,"\n- Button ")
	    print (1,button_link[i])
	    puts(1," is not a valid button!")
	    abort(1)
	end if
    end for
    if mode > 2 then
	text_color(4)
	bk_color(0)
	clear_screen()
	puts(1,"\nERROR....\n\n- Link_button(mode)\n- You specified mode ")
	print(1,mode)
	puts(1,"\n- Mode ")
	print(1,mode)
	puts(1," is mot a valid mode!")
	puts(1,"\n- ST_DOWN and SP_BACK are valid mode types.")
	abort(1)
    end if
    if mode = 2 then
	error = 0
	for i = 1 to length(button_link) by 1 do
	    if button_rack[button_link[i]][3][8] = 1 then
		error = i
	    end if
	end for
	if error = 0 then
	    text_color(4)
	    bk_color(0)
	    clear_screen()
	    puts(1,"\nERROR....\n\n- Link_button({sequence},ST_DOWN)\n")
	    puts(1,"- Sequence missing a SP_BACK button!\n")
	    puts(1,"- You must specify at least one SP_BACK button for this link mode.")
	    abort(1)
	end if
    end if
    for i = 1 to length(button_link) by 1 do
	if length(button_rack[i]) = 5 then
	    text_color(4)
	    bk_color(0)
	    clear_screen()
	    puts(1,"\nERROR....\n\n- Link_button({sequence})\n")
	    puts(1,"- You specified sequence ")
	    print(1,button_link)
	    puts(1,"\n- Button ")
	    print(1,button_rack[i][1])
	    puts(1," is already assighned to link #")
	    print(1,button_rack[i][5][1])
	    puts(1,"!\n")
	    abort(1)
	end if
    end for
-- End syntax check
    link_count = link_count + 1
    for i = 1 to length(button_link) by 1 do
	button_rack[button_link[i]] = append(button_rack[button_link[i]],link_count & mode)
    end for
end procedure
--------------------------------------------------------------------------------
procedure reset_link(sequence link)
    sequence link_rack
    link_rack = {}
    link_status = 1
    for i = 1 to length(button_rack) by 1 do
	if length(button_rack[i]) = 5 and button_rack[i][5][1] = link[5][1] then
	    if button_rack[i][1] < link[1] and button_rack[i][2] = 1 then
	    button_rack[i][2] = -1
	    link_rack = append(link_rack,button_rack[i])
	    elsif button_rack[i][1] > link[1] and button_rack[i][2] = 1 then
		button_rack[i][2] = -1
		link_rack = append(link_rack,button_rack[i])
	    end if
	end if
    end for
    for i = 1 to length(link_rack) by 1 do
	button_display(link_rack[i])
    end for
    link_status = -1
end procedure
link_reset = routine_id("reset_link")
--------------------------------------------------------------------------------
procedure add_text(sequence button_status)
    atom loc_Y,loc_X,text_length
    integer style,color,color_text,direction
    sequence text_input,top,bottom
    top = button_status[3][3..4]
    bottom = button_status[3][5..6]
    color = button_status[3][1]
    direction = length(button_status[4])
    color_text = length(button_status[4])-1
    color_text = button_status[4][color_text]
    text_length = length(button_status[4])-2
    text_input = button_status[4][1..text_length]
    style = button_status[3][7]
    if button_status[4][direction] = 2 then
	direction = 'd'
	text_length = ((text_length * 7.5))
	loc_Y = ((bottom[2] - top[2]) / 2) + (top[2] - text_length)
	loc_X = ((bottom[1] - top[1]) / 2) + (top[1] - 2)
	else direction = 1
	text_length = ((text_length * 7.5) / 2)
	loc_Y = ((bottom[2] - top[2]) / 2) + (top[2] - 7) 
	loc_X = ((bottom[1] - top[1]) / 2) + (top[1] - text_length)
    end if
    if button_status[2] = 1 then
	if style = 1 or style = 6 then
	loc_Y = loc_Y +2
	loc_X = loc_X +2
	elsif style = 2 or style = 7 then
	    loc_Y = loc_Y -2
	    loc_X = loc_X +2
	    elsif style = 3 or style = 8 then
		loc_Y = loc_Y +2
		loc_X = loc_X -2
		elsif style = 4 or style = 9 then
		    loc_Y = loc_Y -2
		    loc_X = loc_X -2
		    elsif style = 5 or style = 10 then
			loc_Y = loc_Y +1
	end if
    end if
    putsxy(floor({loc_X,loc_Y}),text_input,color_text,color,direction)
end procedure
text_button = routine_id("add_text")
--------------------------------------------------------------------------------
global procedure reset_button(integer button)
--Syntax check       
       if button > length(button_rack) then
	text_color(4)
	bk_color(0)
	clear_screen()
	puts(1,"\nERROR....\n\n- Reset_button(button)\n- You specified button ")
	print(1,button)
	puts(1,"\n- Button ")
	print(1,button)
	puts(1," does not exist!")
	abort(1)
       end if
--End syntax check
       if button_rack[button][2] = 1 then
	   button_rack[button][2] = -1
	   call_proc(display_button,{button_rack[button]})
       end if
end procedure
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--END BUTTON ROUTINES
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------

